import numpy as np
import matplotlib.pyplot as plt
import matplotlib.animation as animation

def update_line(num, data, line):
    line.set_data(data[...,:num])
    return line,

fig = plt.figure()

data = np.loadtxt('co2_mm_mlo0.txt',usecols=(2,3),unpack=True)
nlines = data.shape[1]

l, = plt.plot([], [], 'r-')
plt.xlim(1956, 2016)
plt.ylim(300, 410)
plt.xlabel('Year')
plt.ylabel('Atmospheric CO$_2$ (ppm)')
line_ani = animation.FuncAnimation(fig, update_line, nlines, 
            fargs=(data, l), interval=20, blit=False)
line_ani.save('anim_co2.mp4')

plt.show()
