# binary star simulator

from visual import *
import numpy as np

scene = display(title='Binary Star Simulator',width=600,height=600,
                center=(0,3,0))
scene.ambient=color.gray(0.4)
distant_light(direction=(0,-1,0),color=color.gray(0.4))

Rsun = 7.e8
Msun = 2.e30
G = 6.67e-11

M1 = 1.0*Msun  ; R1 = 1.0*Rsun   # solar
M2 = 0.5*Msun  ; R2 = 0.5*Rsun   # M dwarf

M = M1+M2
a = 5*Rsun
a1 = a*M2/M
a2 = a*M1/M
Porb = np.sqrt(4*np.pi**2 / (G*M) * a**3)
v1circ = 2 * np.pi * a1 / Porb
v2circ = 2 * np.pi * a2 / Porb
v1 = 0.8 * v1circ
v2 = v1 * M1/M2

print 'M1, M2, M = ', M1, M2, M
print 'a, a1, a2 = ', a, a1, a2
print 'porb (s) = ',Porb

s1 = sphere (pos=(-a1,0,0), radius=R1, color=color.yellow)
s2 = sphere (pos=(a2,0,0), radius=R2, color=color.red)
cm = arrow(pos=(0,0,0), axis=(0,0,Rsun),color=color.white)
s1.velocity = vector(0,v1,0)
s2.velocity = vector(0,-v2,0)
dt = 250   #seconds

while 1:
    rate (100)
    r12 = s2.pos - s1.pos
    r = mag(r12)
    r12hat = r12 / mag(r12)
    accel1 = G * M2 / r**2 * r12hat
    accel2 = G * M1 / r**2 * -r12hat
    s1.velocity = s1.velocity + accel1*dt
    s2.velocity = s2.velocity + accel2*dt
    s1.pos = s1.pos + s1.velocity*dt
    s2.pos = s2.pos + s2.velocity*dt
    
