import numpy as np
from scipy.optimize import curve_fit
import matplotlib.pyplot as plt

func = lambda x, a, b, c: a + b*x * np.exp(-c*x)

x = np.linspace(0, 6, 20)
noise = 0.05 * np.random.normal(size=len(x))
y = func(x,1,2,1) + noise

sigma = np.ones(len(x))
p0 = np.ones(3)          # initial guesses for a, b, c

p, pcov = curve_fit(func,x,y,p0,sigma)

perr = np.sqrt(np.diag(pcov))

print 'Best-fit:' 
print u'a = {:g} \u00B1 {:g}'.format(p[0],perr[0])
print u'b = {:g} \u00B1 {:g}'.format(p[1],perr[1])
print u'c = {:g} \u00B1 {:g}'.format(p[2],perr[2])

xfit = np.linspace(0,6,100)

plt.plot(x,y,'ko',label='Data')
plt.plot(xfit, func(xfit,p[0],p[1],p[2]),'b-',label='Fit')
plt.legend()
plt.text(4,1.5,"$y = a + bx e^{-cx}$",fontsize=20)
plt.axis([-0.5,6.5,0.92,1.85])
plt.show()
