#!/usr/bin/env python
"""
Plot 2 column data file using a line to connect points
"""

import sys
from numpy import loadtxt
import matplotlib.pyplot as plt

if (len(sys.argv) > 1):
    infile = sys.argv[1]
    x, y = loadtxt(infile,unpack=True,usecols=(0,1))
    fig = plt.figure()
    ax = fig.add_subplot(111)
    ax.plot(x,y)
    xrange = max(x) - min(x)
    yrange = max(y) - min(y)
    minx = min(x)-0.05*xrange
    maxx = max(x)+0.05*xrange
    miny = min(y)-0.05*yrange
    maxy = max(y)+0.05*yrange
    ax.axis([minx,maxx,miny,maxy])
    if (len(sys.argv) > 2):
        title(sys.argv[2])
        
    plt.show()
else:
    print "syntax: pltxy <infile> [title]"
